Bug 986641 - (ghc-shakespeare-js) Review Request: ghc-shakespeare-js - Compile-time variable interpolation for Javascript
Review Request: ghc-shakespeare-js - Compile-time variable interpolation for ...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Sébastien Willmann
Fedora Extras Quality Assurance
:
Depends On: 948699
Blocks: ghc-yesod-core
  Show dependency treegraph
 
Reported: 2013-07-21 04:22 EDT by Jens Petersen
Modified: 2014-03-11 00:20 EDT (History)
3 users (show)

See Also:
Fixed In Version: ghc-shakespeare-js-1.1.3-1.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-03-11 00:16:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
sebastien.willmann: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Jens Petersen 2013-07-21 04:22:17 EDT
Spec URL: http://petersen.fedorapeople.org//ghc-shakespeare-js.spec
SRPM URL: http://petersen.fedorapeople.org//ghc-shakespeare-js-1.1.4-1.fc19.src.rpm

Description:
Shakespeare is a template family for type-safe, efficient templates with simple
variable interpolation. Shakespeare templates can be used inline with a
quasi-quoter or in an external file. Shakespeare interpolates variables
according to the type being inserted. In this case, the variable type needs a
ToJavascript instance.

shakespeare-javascript is alson known as Julius, and passes through plain
javascript

There is also a shakespeare version for CoffeeScript, TypeScript, and Roy, all
languages that compile down to Javascript. They all expect you to have the
appropriate compiler in your path.

shakespeare originated from the hamlet template package. Please see
http://www.yesodweb.com/book/shakespearean-templates for a more thorough
description and examples .
Comment 1 Jens Petersen 2013-08-30 01:17:37 EDT
1.1.4.1 is available but yesod-platform is still on 1.1.4.

Above package built in Rawhide:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5872448
Comment 2 Jens Petersen 2013-10-16 05:37:41 EDT
1.2 is out but I need to update shakespeare for that.
Comment 3 Sébastien Willmann 2014-02-09 08:27:50 EST
A few things to fix in the description:
     alson -> also
     Remove the space before the final dot.
     Add a dot at the end of the second paragraph.

The package seems to contain tests, maybe you can add a check section?

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 8 files have unknown license. Detailed output of
     licensecheck in /home/WilQu/fedpkg/reviews/986641-ghc-shakespeare-
     js/licensecheck.txt

     Note: license not specified in source files.

[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[!]: Spec file is legible and written in American English.

     Remove the space before the final dot.
     Add a dot at the end of the second paragraph.
     alson -> also

[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
     
     Package uses ExclusiveArch: %{ghc_arches_with_ghci}

[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 215040 bytes in 26 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.

     I can load the lib from ghci

[-]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ghc-shakespeare-js-1.1.4-1.fc21.x86_64.rpm
          ghc-shakespeare-js-devel-1.1.4-1.fc21.x86_64.rpm
          ghc-shakespeare-js-1.1.4-1.fc21.src.rpm
ghc-shakespeare-js.x86_64: W: spelling-error %description -l en_US quoter -> quote, quotes, quoted
ghc-shakespeare-js.x86_64: W: spelling-error %description -l en_US javascript -> java script, java-script, JavaScript
ghc-shakespeare-js.x86_64: W: spelling-error %description -l en_US alson -> also, salon, arson
ghc-shakespeare-js.src: W: spelling-error %description -l en_US quoter -> quote, quotes, quoted
ghc-shakespeare-js.src: W: spelling-error %description -l en_US javascript -> java script, java-script, JavaScript
ghc-shakespeare-js.src: W: spelling-error %description -l en_US alson -> also, salon, arson
3 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint ghc-shakespeare-js ghc-shakespeare-js-devel
ghc-shakespeare-js.x86_64: W: spelling-error %description -l en_US quoter -> quote, quotes, quoted
ghc-shakespeare-js.x86_64: W: spelling-error %description -l en_US javascript -> java script, java-script, JavaScript
ghc-shakespeare-js.x86_64: W: spelling-error %description -l en_US alson -> also, salon, arson
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
ghc-shakespeare-js (rpmlib, GLIBC filtered):
    ghc(aeson-0.6.2.1-92173c75149e34c3bea9cafc379c1c76)
    ghc(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    ghc(shakespeare-1.0.5.1-8d63350e724555cd77ded8dab625124c)
    ghc(template-haskell-2.8.0.0-a3012803fde1dc362e555b35a1a78e6d)
    ghc(text-0.11.3.1-e38859e86485c167fa7c9441789e7607)
    libHSaeson-0.6.2.1-ghc7.6.3.so()(64bit)
    libHSarray-0.4.0.1-ghc7.6.3.so()(64bit)
    libHSattoparsec-0.10.4.0-ghc7.6.3.so()(64bit)
    libHSbase-4.6.0.1-ghc7.6.3.so()(64bit)
    libHSblaze-builder-0.3.1.1-ghc7.6.3.so()(64bit)
    libHSbytestring-0.10.0.2-ghc7.6.3.so()(64bit)
    libHScontainers-0.5.0.0-ghc7.6.3.so()(64bit)
    libHSdeepseq-1.3.0.1-ghc7.6.3.so()(64bit)
    libHSdirectory-1.2.0.1-ghc7.6.3.so()(64bit)
    libHSdlist-0.5-ghc7.6.3.so()(64bit)
    libHSfilepath-1.3.0.1-ghc7.6.3.so()(64bit)
    libHSghc-prim-0.3.0.0-ghc7.6.3.so()(64bit)
    libHShashable-1.1.2.5-ghc7.6.3.so()(64bit)
    libHSinteger-gmp-0.5.0.0-ghc7.6.3.so()(64bit)
    libHSmtl-2.1.2-ghc7.6.3.so()(64bit)
    libHSold-locale-1.0.0.5-ghc7.6.3.so()(64bit)
    libHSparsec-3.1.3-ghc7.6.3.so()(64bit)
    libHSpretty-1.1.1.0-ghc7.6.3.so()(64bit)
    libHSprimitive-0.5.0.1-ghc7.6.3.so()(64bit)
    libHSprocess-1.1.0.2-ghc7.6.3.so()(64bit)
    libHSshakespeare-1.0.5.1-ghc7.6.3.so()(64bit)
    libHSsyb-0.4.0-ghc7.6.3.so()(64bit)
    libHSsystem-fileio-0.3.11-ghc7.6.3.so()(64bit)
    libHSsystem-filepath-0.4.7-ghc7.6.3.so()(64bit)
    libHStemplate-haskell-2.8.0.0-ghc7.6.3.so()(64bit)
    libHStext-0.11.3.1-ghc7.6.3.so()(64bit)
    libHStime-1.4.0.1-ghc7.6.3.so()(64bit)
    libHStransformers-0.3.0.0-ghc7.6.3.so()(64bit)
    libHSunix-2.6.0.1-ghc7.6.3.so()(64bit)
    libHSunordered-containers-0.2.3.0-ghc7.6.3.so()(64bit)
    libHSvector-0.10.0.1-ghc7.6.3.so()(64bit)
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libgmp.so.10()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libutil.so.1()(64bit)
    rtld(GNU_HASH)

ghc-shakespeare-js-devel (rpmlib, GLIBC filtered):
    /bin/sh
    ghc(shakespeare-js-1.1.4-d4a1fdcb65d61452688619d0d2102f3f)
    ghc-compiler
    ghc-devel(aeson-0.6.2.1-92173c75149e34c3bea9cafc379c1c76)
    ghc-devel(base-4.6.0.1-8aa5d403c45ea59dcd2c39f123e27d57)
    ghc-devel(shakespeare-1.0.5.1-8d63350e724555cd77ded8dab625124c)
    ghc-devel(template-haskell-2.8.0.0-a3012803fde1dc362e555b35a1a78e6d)
    ghc-devel(text-0.11.3.1-e38859e86485c167fa7c9441789e7607)
    ghc-shakespeare-js(x86-64)



Provides
--------
ghc-shakespeare-js:
    ghc(shakespeare-js-1.1.4-d4a1fdcb65d61452688619d0d2102f3f)
    ghc-shakespeare-js
    ghc-shakespeare-js(x86-64)
    libHSshakespeare-js-1.1.4-ghc7.6.3.so()(64bit)

ghc-shakespeare-js-devel:
    ghc-devel(shakespeare-js-1.1.4-d4a1fdcb65d61452688619d0d2102f3f)
    ghc-shakespeare-js-devel
    ghc-shakespeare-js-devel(x86-64)



Unversioned so-files
--------------------
ghc-shakespeare-js: /usr/lib64/ghc-7.6.3/shakespeare-js-1.1.4/libHSshakespeare-js-1.1.4-ghc7.6.3.so

Source checksums
----------------
http://hackage.haskell.org/packages/archive/shakespeare-js/1.1.4/shakespeare-js-1.1.4.tar.gz :
  CHECKSUM(SHA256) this package     : c3bba5e4ebb914eded23a060beb68f6e76d134aa2a42c8f654c6b118dec51616
  CHECKSUM(SHA256) upstream package : c3bba5e4ebb914eded23a060beb68f6e76d134aa2a42c8f654c6b118dec51616


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/bin/fedora-review -b 986641
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Haskell, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 4 Jens Petersen 2014-02-10 03:05:47 EST
(In reply to Sébastien Willmann from comment #3)
>      alson -> also
>      Remove the space before the final dot.
>      Add a dot at the end of the second paragraph.

Okay sure thanks - I will fix those.

See https://github.com/yesodweb/shakespeare/pull/123

> The package seems to contain tests, maybe you can add a check section?

Right, but we don't have hspec packaged in Fedora yet.
In fact we have been kind of "systematically" ignoring
test-frameworks so it is probably about time we started to
package some of them, but I don't think it needs to block
this review. :)

(I am also planning to update to latest version but that
could be done after - it needs an update of shakespeare anyway.)
Comment 5 Jens Petersen 2014-02-13 20:17:56 EST
So do you prefer to continue the review with the current version
or to wait for bumping to shakespeare-1.2?
Comment 6 Sébastien Willmann 2014-02-14 14:05:50 EST
> Right, but we don't have hspec packaged in Fedora yet.
Ok, that seems a valid reason :) I would suggest adding an empty %check section, with a comment explaining why you can't run the tests.

> So do you prefer to continue the review with the current version
or to wait for bumping to shakespeare-1.2?
I’m ok with the current version if you can't bump it right now.
Comment 7 Jens Petersen 2014-02-23 23:33:19 EST
Cool, sorry for the delay:

Spec: http://petersen.fedorapeople.org/reviews/ghc-shakespeare-js/ghc-shakespeare-js.spec
SRPM: http://petersen.fedorapeople.org/reviews/ghc-shakespeare-js/ghc-shakespeare-js-1.1.4.1-1.fc20.src.rpm

Scratch: http://koji.fedoraproject.org/koji/taskinfo?taskID=6563733

should fix the issues you pointed out above.

(Note 1.1.4+ currently only builds in Rawhide since it needs shakespeare >= 1.0.5.
1.1.3 should build for current F19 and F20 - though I hope to update
at least F20 later to shakespeare-1.2.)
Comment 8 Sébastien Willmann 2014-02-25 13:58:28 EST
The issues have been fixed, package approved.
Comment 9 Jens Petersen 2014-02-25 19:49:27 EST
Thank you for the review.


New Package SCM Request
=======================
Package Name: ghc-shakespeare-js
Short Description: Compile-time variable interpolation for Javascript
Owners: petersen
Branches: f19 f20 el6 epel7
InitialCC: haskell-sig
Comment 10 Gwyn Ciesla 2014-02-26 07:59:53 EST
Git done (by process-git-requests).
Comment 11 Jens Petersen 2014-02-26 22:32:55 EST
Built for F21 Rawhide
Comment 12 Fedora Update System 2014-02-26 22:50:07 EST
ghc-shakespeare-js-1.1.2.1-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/ghc-shakespeare-js-1.1.2.1-1.fc19
Comment 13 Fedora Update System 2014-02-26 22:50:17 EST
ghc-shakespeare-js-1.1.3-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/ghc-shakespeare-js-1.1.3-1.fc20
Comment 14 Fedora Update System 2014-02-28 13:27:16 EST
ghc-shakespeare-js-1.1.3-1.fc20 has been pushed to the Fedora 20 testing repository.
Comment 15 Fedora Update System 2014-03-11 00:16:50 EDT
ghc-shakespeare-js-1.1.2.1-1.fc19 has been pushed to the Fedora 19 stable repository.
Comment 16 Fedora Update System 2014-03-11 00:20:44 EDT
ghc-shakespeare-js-1.1.3-1.fc20 has been pushed to the Fedora 20 stable repository.

Note You need to log in before you can comment on or make changes to this bug.